<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for syncMSISDNChange StructType
 * Meta information extracted from the WSDL
 * - type: sag_data_sync_local_xsd:syncMSISDNChange
 * @subpackage Structs
 */
class SyncMSISDNChange extends AbstractStructBase
{
    /**
     * The MSISDN
     * @var string
     */
    public $MSISDN;
    /**
     * The newMSISDN
     * @var string
     */
    public $newMSISDN;
    /**
     * The extensionInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var mixed
     */
    public $extensionInfo;
    /**
     * Constructor method for syncMSISDNChange
     * @uses SyncMSISDNChange::setMSISDN()
     * @uses SyncMSISDNChange::setNewMSISDN()
     * @uses SyncMSISDNChange::setExtensionInfo()
     * @param string $mSISDN
     * @param string $newMSISDN
     * @param mixed $extensionInfo
     */
    public function __construct($mSISDN = null, $newMSISDN = null, $extensionInfo = null)
    {
        $this
            ->setMSISDN($mSISDN)
            ->setNewMSISDN($newMSISDN)
            ->setExtensionInfo($extensionInfo);
    }
    /**
     * Get MSISDN value
     * @return string|null
     */
    public function getMSISDN()
    {
        return $this->MSISDN;
    }
    /**
     * Set MSISDN value
     * @param string $mSISDN
     * @return \StructType\SyncMSISDNChange
     */
    public function setMSISDN($mSISDN = null)
    {
        // validation for constraint: string
        if (!is_null($mSISDN) && !is_string($mSISDN)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($mSISDN, true), gettype($mSISDN)), __LINE__);
        }
        $this->MSISDN = $mSISDN;
        return $this;
    }
    /**
     * Get newMSISDN value
     * @return string|null
     */
    public function getNewMSISDN()
    {
        return $this->newMSISDN;
    }
    /**
     * Set newMSISDN value
     * @param string $newMSISDN
     * @return \StructType\SyncMSISDNChange
     */
    public function setNewMSISDN($newMSISDN = null)
    {
        // validation for constraint: string
        if (!is_null($newMSISDN) && !is_string($newMSISDN)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($newMSISDN, true), gettype($newMSISDN)), __LINE__);
        }
        $this->newMSISDN = $newMSISDN;
        return $this;
    }
    /**
     * Get extensionInfo value
     * @return mixed|null
     */
    public function getExtensionInfo()
    {
        return $this->extensionInfo;
    }
    /**
     * Set extensionInfo value
     * @param mixed $extensionInfo
     * @return \StructType\SyncMSISDNChange
     */
    public function setExtensionInfo($extensionInfo = null)
    {
        $this->extensionInfo = $extensionInfo;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SyncMSISDNChange
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
