<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for syncOrderRelation StructType
 * Meta information extracted from the WSDL
 * - type: sag_data_sync_local_xsd:syncOrderRelation
 * @subpackage Structs
 */
class SyncOrderRelation extends AbstractStructBase
{
    /**
     * The userID
     * @var mixed
     */
    public $userID;
    /**
     * The spID
     * @var string
     */
    public $spID;
    /**
     * The productID
     * @var string
     */
    public $productID;
    /**
     * The serviceID
     * @var string
     */
    public $serviceID;
    /**
     * The serviceList
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $serviceList;
    /**
     * The updateType
     * @var int
     */
    public $updateType;
    /**
     * The updateTime
     * @var string
     */
    public $updateTime;
    /**
     * The updateDesc
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $updateDesc;
    /**
     * The effectiveTime
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $effectiveTime;
    /**
     * The expiryTime
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $expiryTime;
    /**
     * The extensionInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var mixed
     */
    public $extensionInfo;
    /**
     * Constructor method for syncOrderRelation
     * @uses SyncOrderRelation::setUserID()
     * @uses SyncOrderRelation::setSpID()
     * @uses SyncOrderRelation::setProductID()
     * @uses SyncOrderRelation::setServiceID()
     * @uses SyncOrderRelation::setServiceList()
     * @uses SyncOrderRelation::setUpdateType()
     * @uses SyncOrderRelation::setUpdateTime()
     * @uses SyncOrderRelation::setUpdateDesc()
     * @uses SyncOrderRelation::setEffectiveTime()
     * @uses SyncOrderRelation::setExpiryTime()
     * @uses SyncOrderRelation::setExtensionInfo()
     * @param mixed $userID
     * @param string $spID
     * @param string $productID
     * @param string $serviceID
     * @param string $serviceList
     * @param int $updateType
     * @param string $updateTime
     * @param string $updateDesc
     * @param string $effectiveTime
     * @param string $expiryTime
     * @param mixed $extensionInfo
     */
    public function __construct($userID = null, $spID = null, $productID = null, $serviceID = null, $serviceList = null, $updateType = null, $updateTime = null, $updateDesc = null, $effectiveTime = null, $expiryTime = null, $extensionInfo = null)
    {
        $this
            ->setUserID($userID)
            ->setSpID($spID)
            ->setProductID($productID)
            ->setServiceID($serviceID)
            ->setServiceList($serviceList)
            ->setUpdateType($updateType)
            ->setUpdateTime($updateTime)
            ->setUpdateDesc($updateDesc)
            ->setEffectiveTime($effectiveTime)
            ->setExpiryTime($expiryTime)
            ->setExtensionInfo($extensionInfo);
    }
    /**
     * Get userID value
     * @return mixed|null
     */
    public function getUserID()
    {
        return $this->userID;
    }
    /**
     * Set userID value
     * @param mixed $userID
     * @return \StructType\SyncOrderRelation
     */
    public function setUserID($userID = null)
    {
        $this->userID = $userID;
        return $this;
    }
    /**
     * Get spID value
     * @return string|null
     */
    public function getSpID()
    {
        return $this->spID;
    }
    /**
     * Set spID value
     * @param string $spID
     * @return \StructType\SyncOrderRelation
     */
    public function setSpID($spID = null)
    {
        // validation for constraint: string
        if (!is_null($spID) && !is_string($spID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($spID, true), gettype($spID)), __LINE__);
        }
        $this->spID = $spID;
        return $this;
    }
    /**
     * Get productID value
     * @return string|null
     */
    public function getProductID()
    {
        return $this->productID;
    }
    /**
     * Set productID value
     * @param string $productID
     * @return \StructType\SyncOrderRelation
     */
    public function setProductID($productID = null)
    {
        // validation for constraint: string
        if (!is_null($productID) && !is_string($productID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($productID, true), gettype($productID)), __LINE__);
        }
        $this->productID = $productID;
        return $this;
    }
    /**
     * Get serviceID value
     * @return string|null
     */
    public function getServiceID()
    {
        return $this->serviceID;
    }
    /**
     * Set serviceID value
     * @param string $serviceID
     * @return \StructType\SyncOrderRelation
     */
    public function setServiceID($serviceID = null)
    {
        // validation for constraint: string
        if (!is_null($serviceID) && !is_string($serviceID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($serviceID, true), gettype($serviceID)), __LINE__);
        }
        $this->serviceID = $serviceID;
        return $this;
    }
    /**
     * Get serviceList value
     * @return string|null
     */
    public function getServiceList()
    {
        return $this->serviceList;
    }
    /**
     * Set serviceList value
     * @param string $serviceList
     * @return \StructType\SyncOrderRelation
     */
    public function setServiceList($serviceList = null)
    {
        // validation for constraint: string
        if (!is_null($serviceList) && !is_string($serviceList)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($serviceList, true), gettype($serviceList)), __LINE__);
        }
        $this->serviceList = $serviceList;
        return $this;
    }
    /**
     * Get updateType value
     * @return int|null
     */
    public function getUpdateType()
    {
        return $this->updateType;
    }
    /**
     * Set updateType value
     * @param int $updateType
     * @return \StructType\SyncOrderRelation
     */
    public function setUpdateType($updateType = null)
    {
        // validation for constraint: int
        if (!is_null($updateType) && !(is_int($updateType) || ctype_digit($updateType))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($updateType, true), gettype($updateType)), __LINE__);
        }
        $this->updateType = $updateType;
        return $this;
    }
    /**
     * Get updateTime value
     * @return string|null
     */
    public function getUpdateTime()
    {
        return $this->updateTime;
    }
    /**
     * Set updateTime value
     * @param string $updateTime
     * @return \StructType\SyncOrderRelation
     */
    public function setUpdateTime($updateTime = null)
    {
        // validation for constraint: string
        if (!is_null($updateTime) && !is_string($updateTime)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($updateTime, true), gettype($updateTime)), __LINE__);
        }
        $this->updateTime = $updateTime;
        return $this;
    }
    /**
     * Get updateDesc value
     * @return string|null
     */
    public function getUpdateDesc()
    {
        return $this->updateDesc;
    }
    /**
     * Set updateDesc value
     * @param string $updateDesc
     * @return \StructType\SyncOrderRelation
     */
    public function setUpdateDesc($updateDesc = null)
    {
        // validation for constraint: string
        if (!is_null($updateDesc) && !is_string($updateDesc)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($updateDesc, true), gettype($updateDesc)), __LINE__);
        }
        $this->updateDesc = $updateDesc;
        return $this;
    }
    /**
     * Get effectiveTime value
     * @return string|null
     */
    public function getEffectiveTime()
    {
        return $this->effectiveTime;
    }
    /**
     * Set effectiveTime value
     * @param string $effectiveTime
     * @return \StructType\SyncOrderRelation
     */
    public function setEffectiveTime($effectiveTime = null)
    {
        // validation for constraint: string
        if (!is_null($effectiveTime) && !is_string($effectiveTime)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($effectiveTime, true), gettype($effectiveTime)), __LINE__);
        }
        $this->effectiveTime = $effectiveTime;
        return $this;
    }
    /**
     * Get expiryTime value
     * @return string|null
     */
    public function getExpiryTime()
    {
        return $this->expiryTime;
    }
    /**
     * Set expiryTime value
     * @param string $expiryTime
     * @return \StructType\SyncOrderRelation
     */
    public function setExpiryTime($expiryTime = null)
    {
        // validation for constraint: string
        if (!is_null($expiryTime) && !is_string($expiryTime)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($expiryTime, true), gettype($expiryTime)), __LINE__);
        }
        $this->expiryTime = $expiryTime;
        return $this;
    }
    /**
     * Get extensionInfo value
     * @return mixed|null
     */
    public function getExtensionInfo()
    {
        return $this->extensionInfo;
    }
    /**
     * Set extensionInfo value
     * @param mixed $extensionInfo
     * @return \StructType\SyncOrderRelation
     */
    public function setExtensionInfo($extensionInfo = null)
    {
        $this->extensionInfo = $extensionInfo;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SyncOrderRelation
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
