<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for syncSubscriptionActive StructType
 * Meta information extracted from the WSDL
 * - type: sag_data_sync_local_xsd:syncSubscriptionActive
 * @subpackage Structs
 */
class SyncSubscriptionActive extends AbstractStructBase
{
    /**
     * The userID
     * @var mixed
     */
    public $userID;
    /**
     * The spID
     * @var string
     */
    public $spID;
    /**
     * The productID
     * @var string
     */
    public $productID;
    /**
     * The serviceID
     * @var string
     */
    public $serviceID;
    /**
     * The extensionInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var mixed
     */
    public $extensionInfo;
    /**
     * Constructor method for syncSubscriptionActive
     * @uses SyncSubscriptionActive::setUserID()
     * @uses SyncSubscriptionActive::setSpID()
     * @uses SyncSubscriptionActive::setProductID()
     * @uses SyncSubscriptionActive::setServiceID()
     * @uses SyncSubscriptionActive::setExtensionInfo()
     * @param mixed $userID
     * @param string $spID
     * @param string $productID
     * @param string $serviceID
     * @param mixed $extensionInfo
     */
    public function __construct($userID = null, $spID = null, $productID = null, $serviceID = null, $extensionInfo = null)
    {
        $this
            ->setUserID($userID)
            ->setSpID($spID)
            ->setProductID($productID)
            ->setServiceID($serviceID)
            ->setExtensionInfo($extensionInfo);
    }
    /**
     * Get userID value
     * @return mixed|null
     */
    public function getUserID()
    {
        return $this->userID;
    }
    /**
     * Set userID value
     * @param mixed $userID
     * @return \StructType\SyncSubscriptionActive
     */
    public function setUserID($userID = null)
    {
        $this->userID = $userID;
        return $this;
    }
    /**
     * Get spID value
     * @return string|null
     */
    public function getSpID()
    {
        return $this->spID;
    }
    /**
     * Set spID value
     * @param string $spID
     * @return \StructType\SyncSubscriptionActive
     */
    public function setSpID($spID = null)
    {
        // validation for constraint: string
        if (!is_null($spID) && !is_string($spID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($spID, true), gettype($spID)), __LINE__);
        }
        $this->spID = $spID;
        return $this;
    }
    /**
     * Get productID value
     * @return string|null
     */
    public function getProductID()
    {
        return $this->productID;
    }
    /**
     * Set productID value
     * @param string $productID
     * @return \StructType\SyncSubscriptionActive
     */
    public function setProductID($productID = null)
    {
        // validation for constraint: string
        if (!is_null($productID) && !is_string($productID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($productID, true), gettype($productID)), __LINE__);
        }
        $this->productID = $productID;
        return $this;
    }
    /**
     * Get serviceID value
     * @return string|null
     */
    public function getServiceID()
    {
        return $this->serviceID;
    }
    /**
     * Set serviceID value
     * @param string $serviceID
     * @return \StructType\SyncSubscriptionActive
     */
    public function setServiceID($serviceID = null)
    {
        // validation for constraint: string
        if (!is_null($serviceID) && !is_string($serviceID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($serviceID, true), gettype($serviceID)), __LINE__);
        }
        $this->serviceID = $serviceID;
        return $this;
    }
    /**
     * Get extensionInfo value
     * @return mixed|null
     */
    public function getExtensionInfo()
    {
        return $this->extensionInfo;
    }
    /**
     * Set extensionInfo value
     * @param mixed $extensionInfo
     * @return \StructType\SyncSubscriptionActive
     */
    public function setExtensionInfo($extensionInfo = null)
    {
        $this->extensionInfo = $extensionInfo;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SyncSubscriptionActive
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
